#include <QApplication>
#include <QTextEdit>
#include <QLineEdit>
#include <QPlainTextEdit>
#include <QLabel>
#include <QVBoxLayout>
#include <QListWidget>
#include <QTableWidget>
#include <QDebug>

#ifdef QT_DIAG_LIB
#  include <eventfilter.h>
#endif

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    QStringList args = a.arguments();
    args.pop_front();
#ifdef QT_DIAG_LIB
    if (args.contains("-e")) {
        QtDiag::EventFilter::EventCategories cats = QtDiag::EventFilter::InputMethodEvents
                | QtDiag::EventFilter::KeyEvents;
        a.installEventFilter(new  QtDiag::EventFilter(cats, &a));
    }
#endif

    QWidget w;
    QString t = QT_VERSION_STR;
#if QT_VERSION >= 0x050000
    t += ' ' + QGuiApplication::platformName();
#endif
    w.setWindowTitle(t);
    qDebug() << t;
    QVBoxLayout *l = new QVBoxLayout(&w);
    QLineEdit *le =new QLineEdit("QLineEdit", &w);
    l->addWidget(le);
    QPlainTextEdit *pe = new QPlainTextEdit("QPlainTextEdit", &w);
    l->addWidget(pe);

    QListWidget *lw = new QListWidget(&w);
    QListWidgetItem *lit = new QListWidgetItem("QListWidget1");
    lit->setFlags(lit->flags() | Qt::ItemIsEditable);
    lw->addItem(lit);
    lit = new QListWidgetItem("QListWidget2");
    lit->setFlags(lit->flags() | Qt::ItemIsEditable);
    lw->addItem(lit);
    l->addWidget(lw);

    QTableWidget *tw = new QTableWidget(2, 2, &w);
    QTableWidgetItem *tit = new QTableWidgetItem("QTableWidgetItem11");
    tit->setFlags(tit->flags() | Qt::ItemIsEditable);
    tw->setItem(0, 0 , tit);
    tit = new QTableWidgetItem("QTableWidgetItem12");
    tit->setFlags(tit->flags() | Qt::ItemIsEditable);
    tw->setItem(0, 1, tit);
    tit = new QTableWidgetItem("QTableWidgetItem21");
    tit->setFlags(tit->flags() | Qt::ItemIsEditable);
    tw->setItem(1, 0, tit);
    tit = new QTableWidgetItem("QTableWidgetItem22");
    tit->setFlags(tit->flags() | Qt::ItemIsEditable);
    tw->setItem(1, 1, tit);
    l->addWidget(tw);

    w.move(1000, 200);
    w.show();

    return a.exec();
}
